'use strict';
var branch,
    fs = require('fs'),
    json;

exports.rebranchAndWritePackageJson =
function rebranchAndWritePackageJson(pathToJsonFile, _branch) {

    return rebranch(pathToJsonFile, _branch, true);

};


var rebranch = module.exports =
function rebranch(pathToJsonFile, _branch, writeDirectlyToFile) {

    if (!_branch) {
        throw new TypeError('You need to specify a branch.');
    }

    branch = _branch;

    // If path is not absolute, prefix with local dir.
    if (/^[^\/]/.test(pathToJsonFile)) {
        pathToJsonFile = './' + pathToJsonFile;
    }

    json = require(pathToJsonFile);

    json.dependencies = mapObject(json.dependencies);
    json.devDependencies = mapObject(json.devDependencies);

    if (writeDirectlyToFile) {
        fs.writeFileSync(pathToJsonFile, JSON.stringify(json, null, 4));
    }

    return json;

};


var mapKeysFromObjects = function mapKeysFromObjects(keys, obj) {

    keys.forEach(function rebranchingStrings(_dep) {
        var _value = obj[_dep];

        _value = _value.replace(/(\#).*$/, '$1'+branch);

        obj[_dep] = _value;
    });

    return obj;

};


var mapObject = function mapObject(obj) {

    obj = mapKeysFromObjects(Object.keys(obj), obj);
    return obj;

};
